#include <SPI.h>
#include <LoRa.h>
#include <Wifi.h>
#include <HTTPClient.h>
#include <Adafruit_SHT31.h>
#include <Adafruit_DPS310.h>

// RFW9X pin mappings on our base board
#define SCK 1
#define MISO 3 
#define MOSI 2
#define SS 6
#define RST 0
#define DI0 -1

const char* ssid = "SDNet";
const char* pass = "CapstoneProject";

const char* url = "http://192.168.10.120:3000/submit";

char buf[1024];

void setup() {
  Serial.begin(115200);

  Serial.println("Initializing rx...");
  
  WiFi.begin(ssid, pass);

  SPI.begin(SCK, MISO, MOSI, SS);
  LoRa.setPins(SS, RST, DI0);
  if (!LoRa.begin(915E6)) {
    Serial.println("Failure!");
    while (1);
  } else {
    Serial.println("Success!");
  }
}

void loop() {
  // try to parse packet
  int packetSize = LoRa.parsePacket();
  if (packetSize) {

    while (LoRa.available()) {
      LoRa.readBytes(buf, packetSize);
    }

    if (WiFi.isConnected()) {
      WiFiClient client;
      HTTPClient http;

      http.begin(client, url);
      http.addHeader("Content-Type", "text/plain");
      String data = String(buf);
      data += String("rssi: ") + String(LoRa.packetRssi());
      int resCode = http.POST(data);
      Serial.println("Uploaded data.");
    }
  }
}